/* Copyright C2013 Doug Anson, MIT License
 *
 * Permission is hereby granted, free of charge, to any person obtaining a copy of this software
 * and associated documentation files the "Software", to deal in the Software without restriction,
 * including without limitation the rights to use, copy, modify, merge, publish, distribute,
 * sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is
 * furnished to do so, subject to the following conditions:
 *
 * The above copyright notice and this permission notice shall be included in all copies or
 * substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING
 * BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
 * NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM,
 * DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
 * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
 */

 #include "MBEDLight.h"
 
 #include "LightDimmerAction.h"
 #include "LightSwitchAction.h"

   
 // default constructor
 MBEDLight::MBEDLight(Logger *logger,Transport *transports[NUM_TRANSPORTS],int instance,void *endpoint) : Light(logger,transports,instance,endpoint) {
     // initialize the default light state
     this->initLight();
 }
 
 // destructor
 MBEDLight::~MBEDLight() {   
 }
 
 // initialize the light
 void MBEDLight::initLight() {
     Light::initLight();
     if (this->m_current_state == 1) this->on();
     if (this->m_current_state == 0) this->off();
     if (this->m_current_state == 2) this->blink(); 
 }
 
 // turn ON 
 void MBEDLight::on() { this->logger()->led2On(); this->logger()->led3On(); Light::on(); }
 
 // turn OFF 
 void MBEDLight::off() { this->logger()->led2Off(); this->logger()->led3Off(); Light::off(); }

 // dim 
 void MBEDLight::dim(int value) { Light::dim(value); }