/* Copyright C2013 Doug Anson, MIT License
 *
 * Permission is hereby granted, free of charge, to any person obtaining a copy of this software
 * and associated documentation files the "Software", to deal in the Software without restriction,
 * including without limitation the rights to use, copy, modify, merge, publish, distribute,
 * sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is
 * furnished to do so, subject to the following conditions:
 *
 * The above copyright notice and this permission notice shall be included in all copies or
 * substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING
 * BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
 * NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM,
 * DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
 * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
 */
 
#ifndef _PERSONALITY_H_
#define _PERSONALITY_H_

// Base class support
#include "BaseClass.h"

// Transport support
#include "Transport.h"

// ResourceFactory
#include "ResourceFactory.h"

class Personality : public BaseClass {
    private:
        ResourceFactory   *m_resources;
        
        char               m_name[PERSONALITY_NAME_LEN+1];
        char               m_type[PERSONALITY_NAME_LEN+1];
        
        int                m_external_id;
    
    protected:
        Transport         *m_transports[NUM_TRANSPORTS];
        
    public:
        Personality(Logger *logger,Transport *transports[NUM_TRANSPORTS],int instance,void *endpoint,char *type);
        virtual ~Personality();
       
        Transport *getTransport(int index);

        ResourceFactory *getResourceFactory();      

        char *getName();
        char *getType();
        
        int  getExternalID();
        void setExternalID(int id);
        
    protected:
};

#endif // _PERSONALITY_H_