/* Copyright C2013 Doug Anson, MIT License
 *
 * Permission is hereby granted, free of charge, to any person obtaining a copy of this software
 * and associated documentation files the "Software", to deal in the Software without restriction,
 * including without limitation the rights to use, copy, modify, merge, publish, distribute,
 * sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is
 * furnished to do so, subject to the following conditions:
 *
 * The above copyright notice and this permission notice shall be included in all copies or
 * substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING
 * BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
 * NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM,
 * DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
 * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
 */
 
#ifndef _PHILIPS_LIGHT_H_
#define _PHILIPS_LIGHT_H_

#include "Definitions.h"
#include "BaseClass.h"

class PhilipsLight : public BaseClass {
    private:
        int           m_id;
        void         *m_transport;
        char          m_url[PL_URL_BUFFER_LEN+1];
        char          m_payload[PL_PAYLOAD_BUFFER_LEN+1];
        char          m_response[PL_RESPONSE_BUFFER_LEN+1];
        int           m_state;
        int           m_dim;
        
    public:
        PhilipsLight(int id,void *transport,Logger *logger);
        virtual ~PhilipsLight();
       
       void on();
       void off();
       void dim(int dim);
       void update();
 };

#endif // _PHILIPS_LIGHT_H_