/* Copyright C2013 Doug Anson, MIT License
 *
 * Permission is hereby granted, free of charge, to any person obtaining a copy of this software
 * and associated documentation files the "Software", to deal in the Software without restriction,
 * including without limitation the rights to use, copy, modify, merge, publish, distribute,
 * sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is
 * furnished to do so, subject to the following conditions:
 *
 * The above copyright notice and this permission notice shall be included in all copies or
 * substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING
 * BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
 * NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM,
 * DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
 * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
 */
 
 #include "Transport.h"
 
 // default constructor
 Transport::Transport(Logger *logger,void *endpoint) : BaseClass(logger,endpoint) {
     this->m_connected = false;
 }
 
 // default destructor
 Transport::~Transport() {
 }
 
 // check transport and process stuff
 void Transport::checkAndProcess() {
     // default is no action
     ;
 }
  
 // load the endpoint (base class does nothing)
 bool Transport::loadEndpoint(char *data,int data_length,char *result,int result_length) { return false; }
 
 // update the endpoing (base class does nothing)
 bool Transport::updateEndpoint(int ioc_id,char *data,int data_length,char *result,int result_length) { return false; }
 
  // connect
 bool Transport::connect() { return this->m_connected; }
 
 // disconnect
 bool Transport::disconnect() { return true; }
